Package: fcm
Type: Package
Title: Inference of Fuzzy Cognitive Maps (FCMs)
Version: 0.1.3
Date: 2017-07-09
Author: Zoumpoulia Dikopoulou <dikopoulia@gmail.com> <zoumpolia.dikopoulou@uhasselt.be>, Elpiniki Papageorgiou <epapageorgiou@teiste.gr>, <e.i.papageorgiou75@gmail.com>
Maintainer: Zoumpoulia Dikopoulou <dikopoulia@gmail.com>
Description: Provides a selection of 3 different inference rules (including additionally the clamped types of the referred inference rules) and 4 threshold functions in order to obtain the inference of the FCM (Fuzzy Cognitive Map). Moreover, the 'fcm' package returns a data frame of the concepts' values of each state after the inference procedure. Fuzzy cognitive maps were introduced by Kosko (1986) <doi:10.1002/int.4550010405> providing ideal causal cognition tools for modeling and simulating dynamic systems.
License: GPL-2
Encoding: UTF-8
LazyData: true
RoxygenNote: 6.0.1
Imports: reshape2, ggplot2
VignetteBuilder: knitr
Suggests: knitr, rmarkdown
NeedsCompilation: no
Packaged: 2017-07-09 22:34:11 UTC; lucp8904
Repository: CRAN
Date/Publication: 2017-07-09 22:44:14 UTC
Built: R 4.6.0; ; 2026-04-26 07:23:53 UTC; unix

# FCM

[![Build Status](https://travis-ci.org/metomi/fcm.svg?branch=master)](https://travis-ci.org/metomi/fcm)
[![DOI](https://zenodo.org/badge/6402932.svg)](https://zenodo.org/badge/latestdoi/6402932)

FCM: a modern Fortran build system,
and wrappers to Subversion for scientific software development

[Installation](http://metomi.github.io/fcm/doc/installation/) |
[User Guide](http://metomi.github.io/fcm/doc/user_guide/) |
[How to Contribute](CONTRIBUTING.md)

## Copyright and Terms of Use

Copyright (C) 2006-2021 British Crown (Met Office) & Contributors.

FCM is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

FCM is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FCM. If not, see <http://www.gnu.org/licenses/>.

FCM documentation is licensed under the British Open Government
Licence. See doc/etc/fcm-terms-of-use.html and
<http://www.nationalarchives.gov.uk/doc/open-government-licence/>

See <http://metomi.github.io/fcm/doc/etc/fcm-terms-of-use.html>.

## Acknowledgement for Non-FCM Work

See [Acknowledgement for Non-FCM Work](ACKNOWLEDGEMENT.md).

This directory contains the files necessary to set up a Subversion repository
for the FCM tutorial.

For example (in bash/ksh):

(shell)$ cd fcm-release/tutorial/ # to this directory
(shell)$ ./fcm-tutorial-repos-create /path/to/tutorial/repos

The repository should be configured to allow users write access. You may find
it easiest to simply allow anonymous access.

A Trac environment should be configured to be associated with the tutorial
repository. You then need to allow users write access. You may find it easiest
to set up a number of guest accounts for this purpose.

program greet
implicit none
include 'hello.interface'
include 'hi.interface'
abstract interface
subroutine abstract_greet()
end subroutine abstract_greet
end interface
procedure(abstract_greet), pointer :: say
say => hello
call say()
say => hi
call say()
end program greet

! A module with nonsense
module bar
type food
integer :: cooking_method
end type food
type organic
integer :: growing_method
end type organic
integer, parameter :: i_am_dim = 10
end module bar

! A module with more nonsense
module foo
use bar, only: FOOD
integer :: foo_int
contains
subroutine foo_sub(egg)
integer, parameter :: egg_dim = 10
type(Food), intent(in) :: egg
write(*, *) egg
end subroutine foo_sub
elemental function foo_func() result(f)
integer :: f
f = 0
end function
end module foo

module simple_mod

  implicit none

  interface
    module function returnerer(thing)
      implicit none
      integer, intent(in) :: thing
      integer :: returnerer
    end function returnerer
  end interface

end module simple_mod

module greet_mod
implicit none
character(*), parameter :: greet_word = 'Hello'
contains
subroutine greet(world)
character(*), intent(in) :: world
write(*, '(a,1x,a)') greet_word, world
end subroutine greet
end module greet_mod

PROGRAM Hello

USE Hello_Constants, ONLY: hello_string

IMPLICIT NONE

INTEGER :: integer_arg = 1234

#if defined(CALL_HELLO_SUB)
INCLUDE 'hello_sub.interface'
#endif

CHARACTER (LEN=*), PARAMETER :: this = 'Hello'

WRITE (*, '(A)') this // ': ' // TRIM (hello_string)
#if defined(CALL_HELLO_SUB)
CALL Hello_Sub (integer_arg)
#endif

END PROGRAM Hello

MODULE hello_number

IMPLICIT NONE

PRIVATE
INTEGER, PARAMETER :: i=0
INTEGER, PARAMETER :: huge_number=HUGE(i)

PUBLIC hello_huge_number

CONTAINS
SUBROUTINE hello_huge_number()
CHARACTER(LEN=*), PARAMETER :: this='hello_huge_number'
WRITE(*, '(A,I0)') this // ': maximum integer: ', huge_number
END SUBROUTINE hello_huge_number

END MODULE hello_number

module m1
character(*), parameter :: WHATEVER
contains
subroutine s1()
write(*, '(a)') f1() // ' from s1'
end subroutine s1
function f1()
use m2, only: HELLO
character(len=len(HELLO)) :: f1
f1 = hello
end function f1
end module m1

program hi
character(5) :: w
interface
subroutine greet(hello, world)
character(*), intent(in) :: hello, world
end subroutine greet
subroutine world(w)
character(*), intent(out) :: w
end subroutine world
end interface
call world(w)
call greet('Hello', w)
end program hi

#if defined(HELLO_SUB)
SUBROUTINE Hello_Sub (integer_arg)

USE Hello_Constants, ONLY: hello_string

IMPLICIT NONE

CHARACTER (LEN=*), PARAMETER :: this = 'Hello_Sub'
INTEGER :: integer_arg
INTEGER :: integer_common
COMMON /general/integer_common

! DEPENDS ON: hello_c.o
EXTERNAL Hello_C

#include "hello_sub_dummy.h"

WRITE (*, '(A,I0)') this // ': integer (arg): ', integer_arg
WRITE (*, '(A,I0)') this // ': integer (common): ', integer_common

CALL Hello_C ()

END SUBROUTINE Hello_Sub
#endif

PROGRAM Hello

USE Hello_Constants, ONLY: hello_string, Hello_Sub_Wrapper

IMPLICIT NONE

INTEGER :: integer_arg = 1234

CHARACTER (LEN=*), PARAMETER :: this = 'Hello'

WRITE (*, '(A)') this // ': ' // TRIM (hello_string)
CALL Hello_Sub_Wrapper (integer_arg)

END PROGRAM Hello

module m2
contains
subroutine s2(n, z, y)
integer, intent(in) :: n
real, intent(out) :: z(:)
real, intent(in) :: y(:)
integer :: i
!$omp parallel do shared(z)
do i = 1, n
    z(i) = y(i) * 3.0
end do
!$omp end parallel do
end subroutine s2
end module m2

program p1

!$ use omp_lib
!$ use m1, only: s1

integer, parameter :: n=100
integer :: i
real :: x(n), y(n), z(n)

include 's3.interface'

x(:) = 1.0
y(:) = 1.0
z(:) = 1.0
!$ include "i1.f90"
call s3(n, z, y)
do i = 1, n
    write(*, '(f3.1)') z(i)
end do

end program p1

module m1
contains
subroutine s1(n, y, x)
integer, intent(in) :: n
real, intent(out) :: y(:)
real, intent(in) :: x(:)
integer :: i
!$omp parallel do shared(y)
do i = 1, n
    y(i) = x(i) * 2.0
end do
!$omp end parallel do
end subroutine s1
end module m1

PROGRAM hello

USE Hello_Constants, ONLY: hello_string

IMPLICIT NONE
INCLUDE 'hello_sub.interface'
CHARACTER(*), PARAMETER :: this='hello'

WRITE(*, '(A)') this // ': ' // TRIM(hello_string)
CALL Hello_Sub()

END PROGRAM hello

submodule(class_mod) class_impl

  implicit none

contains

  module function bar_initialiser( starter ) result(instance)
    implicit none
    integer, intent(in) :: starter
    type(bar_type) :: instance
    instance%stuff = starter
  end function bar_initialiser


  module subroutine bar_mangle(this, factor)
    implicit none
    class(bar_type), intent(inout) :: this
    integer,         intent(in)    :: factor
    this%stuff = ieor(this%stuff, factor)
  end subroutine bar_mangle


  module procedure bar_howmuch ! Alternative syntax
    bar_howmuch = this%stuff
  end procedure bar_howmuch

end submodule class_impl

SUBROUTINE hello_sub

USE hello_constants, ONLY: hello_string
USE hello_number, ONLY: hello_huge_number

IMPLICIT NONE
CHARACTER(*), PARAMETER :: this = 'hello_sub'
! DEPENDS ON: hello_c.o
EXTERNAL hello_c

WRITE(*, '(A)') this // ': ' // TRIM(hello_string)
CALL hello_huge_number()
CALL hello_c()

END SUBROUTINE hello_sub

! A simple function
logical function func_simple()
func_simple = .true.
end function func_simple

! A simple function, but with less friendly end
logical function func_simple_1()
func_simple_1 = .true.
end function

! A simple function, but with even less friendly end
logical function func_simple_2()
func_simple_2 = .true.
end

! A pure simple function
pure logical function func_simple_pure()
func_simple_pure = .true.
end function func_simple_pure

! A pure recursive function
recursive pure integer function func_simple_recursive_pure(i)
integer, intent(in) :: i
if (i <= 0) then
    func_simple_recursive_pure = i
else
    func_simple_recursive_pure = i + func_simple_recursive_pure(i - 1)
end if
end function func_simple_recursive_pure

! An elemental simple function
elemental logical function func_simple_elemental()
func_simple_elemental = .true.
end function func_simple_elemental

! An function with arguments and module imports
integer(selected_int_kind(0)) function func_with_use_and_args(egg, ham)
use foo
! Deliberate trailing spaces in next line
use bar, only : organic,     i_am_dim   
implicit none
integer, intent(in) :: egg(i_am_dim)
integer, intent(in) :: ham(i_am_dim, 2)
real bacon
! Deliberate trailing spaces in next line
type(   organic   ) :: tomato   
func_with_use_and_args = egg(1) + ham(1, 1)
end function func_with_use_and_args

! A function with some parameters
character(20) function func_with_parameters(egg, ham)
implicit none
character*(*), parameter :: x_param = '01234567890'
character(*), parameter :: & ! throw in some comments
    y_param                &
    = '!&!&!&!&!&!'          ! how to make life interesting
integer, parameter :: z = 20
character(len(x_param)), intent(in) :: egg
character(len(y_param)), intent(in) :: ham
func_with_parameters = egg // ham
end function func_with_parameters

! A function with some parameters, with a result
function func_with_parameters_1(egg, ham) result(r)
implicit none
integer, parameter :: x_param = 10
integer z_param
parameter(z_param = 2)
real, intent(in), dimension(x_param) :: egg
integer, intent(in) :: ham
logical :: r(z_param)
r(1) = int(egg(1)) + ham > 0
r(2) = .false.
end function func_with_parameters_1

! A function with a contains
character(10) function func_with_contains(mushroom, tomoato)
character(5) mushroom
character(5) tomoato
func_with_contains = func_with_contains_1()
contains
character(10) function func_with_contains_1()
func_with_contains_1 = mushroom // tomoato
end function func_with_contains_1
end function func_with_contains

! A function with its result declared after a local in the same statement
Function func_mix_local_and_result(egg, ham, bacon) Result(Breakfast)
Integer, Intent(in) :: egg, ham
Real, Intent(in) :: bacon
Real :: tomato, breakfast
Breakfast = real(egg) + real(ham) + bacon
End Function func_mix_local_and_result

! A simple subroutine
subroutine sub_simple()
end subroutine sub_simple

! A simple subroutine, with not so friendly end
subroutine sub_simple_1()
end subroutine

! A simple subroutine, with even less friendly end
subroutine sub_simple_2()
end

! A simple subroutine, with funny continuation
subroutine sub_simple_3()
end sub&
&routine&
& sub_simple_3

! A subroutine with a few contains
subroutine sub_with_contains(foo) ! " &
! Deliberate trailing spaces in next line
use Bar, only: i_am_dim    
character*(len('!"&''&"!')) & ! what a mess!
    foo
call sub_with_contains_first()
call sub_with_contains_second()
call sub_with_contains_third()
print*, foo
contains
subroutine sub_with_contains_first()
interface
integer function x()
end function x
end interface
end subroutine sub_with_contains_first
subroutine sub_with_contains_second()
end subroutine
subroutine sub_with_contains_third()
end subroutine
end subroutine sub_with_contains

! A subroutine with a renamed module import
subroutine sub_with_renamed_import(i_am_dim)
use bar, only: i_am_not_dim => i_am_dim
integer, parameter :: d = 2
complex :: i_am_dim(d)
print*, i_am_dim
end subroutine sub_with_renamed_import

! A subroutine with an external argument
subroutine sub_with_external(proc)
external proc
call proc()
end subroutine sub_with_external

! A subroutine with an external argument, 2
! https://github.com/metomi/fcm/issues/175
subroutine sub_with_external2(PROC)
external proc
call proc()
end subroutine sub_with_external2

! A subroutine with an external argument, 3
! https://github.com/metomi/fcm/issues/175
subroutine sub_with_external3(proc)
external PROC
call proc()
end subroutine sub_with_external3

! A subroutine with a variable named "end"
subroutine sub_with_end()
integer :: end
end = 0
end subroutine sub_with_end

! A module with nonsense
module stuff
character(*), parameter :: stuffing = 'yummy'
contains
subroutine matter()
print*, 'Matter is not dark'
end subroutine matter
end module stuff

PROGRAM Hello

#if !defined(LOCAL_STRING)
USE Hello_Constants, ONLY: hello_string
#endif

IMPLICIT NONE

#if defined(LOCAL_STRING)
CHARACTER (LEN=80), PARAMETER :: hello_string = 'Hello Mother Earth!'
#endif

INTEGER :: integer_arg = 1234

#if defined(CALL_HELLO_SUB)
INCLUDE 'hello_sub.interface'
#endif

CHARACTER (LEN=*), PARAMETER :: this = 'Hello'

WRITE (*, '(A)') this // ': ' // TRIM (hello_string)
#if defined(CALL_HELLO_SUB)
CALL Hello_Sub (integer_arg)
#endif

END PROGRAM Hello

program test

  use iso_fortran_env, only : output_unit

  use class_mod,  only : bar_type
  use simple_mod, only : returnerer

  implicit none

  type(bar_type) :: thing

  thing = bar_type(12)

  write(output_unit, '("Returner ", I0)') returnerer(7)
  write(output_unit, '()')

  write(output_unit, '("Start with ", I0)') thing%how_much()
  call thing%mangle(17)
  write(output_unit, '("After mangle ", I0)') thing%how_much()

end program test

module class_mod

  implicit none

  type, abstract :: foo_type
    private
    integer :: stuff
  contains
    private
    procedure(mangle_if),   public, deferred :: mangle
    procedure(how_much_if), public, deferred :: how_much
  end type foo_type

  interface
    subroutine mangle_if(this, factor)
      import foo_type
      class(foo_type), intent(inout) :: this
      integer,         intent(in) :: factor
    end subroutine mangle_if
    function how_much_if(this)
      import foo_type
      class(foo_type), intent(inout) :: this
      integer :: how_much_if
    end function how_much_if
  end interface

  type, extends(foo_type) :: bar_type
    private
  contains
    private
    procedure, public :: mangle   => bar_mangle
    procedure, public :: how_much => bar_howmuch
  end type bar_type

  interface bar_type
    procedure bar_initialiser
  end interface bar_type

  interface
    module function bar_initialiser(starter) result(instance)
      integer,intent(in) :: starter
      type(bar_type) :: instance
    end function bar_initialiser
    module subroutine bar_mangle(this, factor)
      class(bar_type), intent(inout) :: this
      integer,         intent(in) :: factor
    end subroutine bar_mangle
    module function bar_howmuch(this)
      class(bar_type), intent(inout) :: this
      integer :: bar_howmuch
    end function bar_howmuch
  end interface

end module class_mod

submodule(simple_mod) simple_impl

  implicit none

contains

  module function returnerer(thing)

    implicit none

    integer, intent(in) :: thing
    integer :: returnerer

    returnerer = 2 * thing

  end function returnerer

end submodule simple_impl

SUBROUTINE Hello_Sub2

USE Hello_Constants, ONLY: hello_string

IMPLICIT NONE

CHARACTER (LEN=*), PARAMETER :: this = 'Hello_Sub2'

WRITE (*, '(A)') this // ': ' // TRIM (hello_string)

END SUBROUTINE Hello_Sub2

program hello
character(5) :: w
interface
subroutine greet(hi, world)
character(*), intent(in) :: hi, world
end subroutine greet
subroutine world(w)
character(*), intent(out) :: w
end subroutine world
end interface
call world(w)
call greet('Hello', w)
end program hello

#!/bin/sh

echo "### Fortran compiler tests"
for fc in \
  "ifort" \
  "ifort -assume nosource_include" \
  "gfortran" \
  "gfortran -I-"
do
  echo
  echo "Compiler: $fc"
  echo "Fortran include test:"
  $fc -o test.o -I$PWD/inc -c prog/test_fortran_inc.f90
  $fc -o test.exe test.o
  test.exe
  rm test.exe test.o
  echo "CPP include test:"
  $fc -o test.o -I$PWD/inc -c prog/test_prepro_inc.F90
  $fc -o test.exe test.o
  test.exe
  rm test.exe test.o
done

echo
echo "### Preprocessor tests"
fc=gfortran
for cpp in \
  "cpp -P -traditional" \
  "cpp -P -traditional -I-"
do
  echo
  echo "Pre-processor: $cpp"
  $cpp -I$PWD/inc prog/test_prepro_inc.F90 >tmp.f90
  $fc -o test.o -I$PWD/inc -c tmp.f90
  $fc -o test.exe test.o
  test.exe
  rm test.exe test.o tmp.f90
done

---
title: "Inference of Fuzzy Cognitive Maps (FCMs)"
author: "Zoumpoulia Dikopoulou, Elpiniki Papageorgiou"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Inference of Fuzzy Cognitive Maps (FCMs)}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

<br>

###The fcm package

Estimates the Inference of a Fuzzy Cognitive Map. Moreover, the "**fcm**" package provides a selection of **3 different inference rules** and **4 threshold functions** in order to obtain the FCM inference. It returns a dataframe of the concepts' values of each state after the inference procedure. FCM is proven to be capable of causal inference and is applicable to modeling complex decision problems where numerous interlinked dependent variables influence one another. 

<br>
 
####Fuzzy Cognitive Maps (FCMs)

Fuzzy Cognitive Map is a combination of fuzzy logic and cognitive mapping, and it is a way to represent knowledge of systems which are characterized of uncertainty and complex processes. FCMs were introduced by Kosko and since then they have gradually emerged as a powerful paradigm for knowledge representation. FCMs are ideal causal cognition tools for modeling and simulating dynamic systems. 

FCMs are fuzzy signed directed graphs with feedback. Each interconnection between two concepts $C_{i}$ and $C_{j}$ has a weight, a directed edge $w_{ij}$, which indicates the strength of the causal relationships between concepts $C_{i}$ and $C_{j}$. The value of the weight $w_{ij}$ indicates how strongly the concept $C_{i}$ influences concept $C_{j}$.The time varying concept function $C_{i}(t)$ measures the non negative occurrence of some fuzzy event. There are three possible types of causal relationship between concept $C_{i}$ and concept $C_{j}$, according to the sign of the weight $w_{ij}$:

1. $w_{ij}>0$ indicates a positive causality between concept $C_{i}$ and concept $C_{j}$. This means that an increase/decrease in the value of concept $C_{i}$ leads to the increase/decrease of the value of concept $C_{j}$. (positive causality)
2. $w_{ij}<0$ indicates a negative (inverse) causality between concept $C_{i}$ and concept $C_{j}$. This means that an increase in the value of concept $C_{i}$ leads to a decrease of the value of concept $C_{j}$ and a decrease of the value of concept $C_{i}$ leads to an increase of the value of concept $C_{j}$. ( negative causality)
3. $w_{ij}=0$ indicates no relationship between concept $C_{i}$ and $C_{j}$. (zero causality) 

<br>

#### Inference Rules
Every concept in the FCM graph has a value $A_{i}$ that expresses the quantity of its corresponding physical value and it is derived by the transformation of the fuzzy values assigned by the experts to numerical values. The value $A_{i}$ of each concept $C_{i}$ is calculated during each simulation step, computing the influence of other concepts to the specific concept by selecting one of the following equations (inference rules): 


| **Inference Rule**         |      **Equation**                                                                |
|----------------------------|:--------------------------------------------------------------------------------:|
| Kosko's  inference:        | $A_{i}(k+1)=f\left(\sum_{j=1,j\neq1}^Nw_{ji}\times A_{j}(k)\right)$              |
| modified Kosko's inference:| $A_{i}(k+1)=f\left(A_{i}(k)+\sum_{j=1,j\neq1}^Nw_{ji}\times A_{j}(k)\right)$      |
| Rescale inference:         | $A_{i}(k+1)=f\left((2\times A_{i}(k)-1)+\sum_{j=1,j\neq1}^Nw_{ji}\times (2\times A_{j}(k)-1)\right)$ |
|                            |                                                                                    |

where $A_{i}(k+1)$ is the value of concept $C_{i}$ at simulation step $k+1$, $A_{j}(k)$ is the value of concept $C_{j}$ at the simulation step $k$, $w_{ij}$ is the weight of the interconnection between concept $C_{j}$ and concept $C_{i}$, $k$ is the interaction index an every simulation step and $f(·)$ is the threshold (activation) function:


| **Threshold function** |      **Equation**                                                                      |
|------------------------|:--------------------------------------------------------------------------------------:|
| Bivalent:              | \[f(x)= \left\{\begin{array}{ll} 1 & x > 0 \\0 & x\leq 0 \\\end{array} \right.\]       |
| Trivalent:             | \[f(x)= \left\{\begin{array}{ll} 1 & x > 0 \\0 & x=0 \\-1 & x<0 \\\end{array} \right.\]|
| Sigmoid:               | $f(x)=\frac{1}{1+e^{-\lambda\times x}}$                                                |
| Hyperbolic tangent:    |  $f(x)=\tanh(\lambda\times x)$                                                         |
|                        |                                                                                        |

       
where $\lambda$ is a real positive number ($\lambda>0$) which determines the steepness of the continuous function $f$ and $x$ is the value $A_{i}(k)$ on the equilibrium point. The sigmoid threshold function ensures that the calculated value of each concept will belong to the interval [0,1]. When the values of concepts can be negative and their values belong to the interval [-1,1], the following function is used: $f(x)=tanh(x)$. The FCM model of the system takes the initial values of concepts and weights based on experts knowledge and experience for the real system and then it is free to interact. At each step, the value $A_{i}$ of a concept is influenced by the values of concepts connected to it and it is updated according to the inference rule.

<br>

> **NOTE**: Except the inference rules that mentioned above, the clamping types of these rules are determined (Kosko-clamped, modified Kosko-clamped and Rescale-clamped). In this case, the activated concepts (concept's value equals to 1) are activated in all states in the FCM simulation until the output is stabilized.

<br><br>


## How is it possible to obtain the FCM inference using R?

### Step 1: Load the fcm package
```{r}
library(fcm)
```

<br><br>

### Step 2: Create (or import) the weight matrix and the activation vector 

The **weight matrix** stores the weights assigned to the pairs of concepts which are usually normalized to the interval $[0, 1]$ or $[-1, +1]$. The dimension of the weight matrix is *m x m*, where m denotes the number of the columns (nodes). 

The **activation vector** contains the initial concept values which each concept is turned on or activated by making its vector element 1 or 0 or in $[0, 1]$. The dimension of the activation matrix is *1 x m*.

> **NOTE**: Both of these input arguments should be transformed as **dataframes**.


```{r }
act.vec <- data.frame(1, 1, 1, 0, 0, 0)    # Create the activation vector
colnames(act.vec) <- c("C1", "C2", "C3", "C4", "C5", "C6")  # Change the column names

C1 = c(0.0, 0.0, 0.6, 0.9, 0.0, 0.0)
C2 = c(0.1, 0.0, 0.0, 0.0, 0.0, 0.0)
C3 = c(0.0, 0.7, 0.0, 0.0, 0.9, 0.0)
C4 = c(0.0, 0.0, 0.0, 0.0, 0.0, 0.9)
C5 = c(0.0, 0.0, 0.0, 0.0, 0.0, -0.9)
C6 = c(-0.3, 0.0, 0.0, 0.0, 0.0, 0.0)


w.mat <- matrix(c(C1, C2, C3, C4, C5, C6), nrow =6, ncol=6, byrow=TRUE)   # Create the weight matrix
w.mat <- as.data.frame(w.mat)    # Transform w.mat as a dataframe
colnames(w.mat) <- c("C1", "C2", "C3", "C4", "C5", "C6") 
w.mat       # View the weight matrix
```

> **NOTE**: It is possible to import a file (for instance a .csv file), typing the file path. <br>
> `w.mat <- read.csv("C://type_the_file_path//name_of_file.csv")` <br>
> 
> *For more information about reading **.csv** files, type in R console:* `?read.csv`.


<br><br>

### Step 3: Use the fcm.infer function 

There are seven input arguments in the `fcm.infer` function: 


| **Arguments**    |      **Explanation**                                                                   |
|------------------|-------------------------------------------------------------------------------------- |
| **activation_vec**  | The activation vector contains the initial concept values which each concept is turned on or activated by making its vector element 1 or 0 or in $[0,1]$      |
| **weight_mat**      | The weight matrix stores the weights assigned to the pairs of concepts which are usually normalized to the interval $[0, 1]$ or $[-1, +1]$ 
| **iter**            | The number of iterations is a positive number ($iter > 0$). *Default value: $iter = 20$* |
| **infer**           | Six different inference rules are available (Kosko: `'k'`, modified Kosko: `'mk'`,  Rescale: `'r'`, Kosko-clamped: `'kc'`, modified Kosko-clamped: `'mkc'` or Rescale-clamped: `'rc'`).         *Default value: `infer = 'k'` *  |
| **transform**       | Four transformation functions (Bivalent: `'b'`,  Trivalent: `'tr'`,  Sigmoid: `'s'` or Hyperbolic tangent: `'t'`). *Default value: transform = `'s'`* |
| **lambda**           | The lambda ($\lambda$) parameter is a positive number, higher than zero and lower-equal to ten, $0<\lambda\leq10$. *Default value: $lambda = 1$ *|
| **e**                | Epsilon ($\epsilon$) is a residual, describing the minimum error difference among the subsequent concepts. Its value depends on the application type. The possible $e$ value is determined between `0.01` and `0.000001`. *Default value: $e = 0.001$*  |
|                  |                                                                                        |



<br>

The `fcm.infer` function prints a message to inform the user if the convergence has been reached or not.

* If the convergence has been reached then the converged state (fixed point) is printed: 

*`"The concepts' values are converged in the ith state"`*.

<br>

* If the convergence has not been reached a message informs the user that more iterations required: 

*`"More iterations are required to reach the convergence"`*.

<br><br>


#### Examples to obtain the FCM Inference  

**Example 1: Estimate the FCM Inference (using the default values of the function)**

```{r }
output1 <- fcm.infer(act.vec, w.mat)
```

<br>

**Example 2: Estimate the FCM Inference (changing the default values)**

The FCM Inference (fcm.infer) function is using the rescale `'r'` inference rule, the sigmoid `'s'` transformation function, the lambda parameter equals to 2 `lambda = 2` and the e parameter `e = 0.0001`.

```{r }
output2 <- fcm.infer(act.vec, w.mat, 35, "r", "s", lambda = 2, e = 0.0001)
output2$values          # View the concepts' values for each iteration
```

<br><br>

### Step 4: Visualize the concepts' values for each iteration

For the visualization of the concepts' values for each iteration after the inference process, it is crucial to load the libraries: `reshape` and `ggplot2`. 

```{r }
# load the libraries
library (reshape2)
library (ggplot2)
```
<br>


**Visualization of Example 1:**
```{r, fig.width=7,fig.height=4}
iterations <- as.numeric(rownames(output1$values))  # create a numeric vector named "iterations"
df <- data.frame(iterations, output1$values)   # add "iterations" in the "output1$values" dataframe
df2 <- melt(df, id="iterations")              # transform the dataframe df into long formats
ggplot(data=df2,                              # Visualize the concepts' values 
       aes(x=iterations, y=value, group=variable, colour=variable)) +
       theme_bw() + geom_line(size=0.7) + geom_point(size = 3)

```

<br><br>

**Visualization of Example 2:**
```{r, fig.width=7,fig.height=4}
iterations <- as.numeric(rownames(output2$values))  
df <- data.frame(iterations, output2$values)   
df2 <- melt(df, id="iterations")              
ggplot(data=df2,
       aes(x=iterations, y=value, group=variable, colour=variable)) +
       theme_bw() + geom_line(size=0.7) + geom_point(size = 3)

```

<br>

###References

1. B. Kosko, "Fuzzy cognitive maps", International Journal of Man-Machine Studies 24,  65-75, 1986.
2. C.D. Stylios, P.P, Groumpos, "A Soft Computing Approach for Modelling the Supervisor of Manufacturing Systems", Intelligent and Robotic Systems, VOl. 26, p.p. 389–403, 1999. 
3. E.I. Papageorgiou, "A new methodology for Decisions in Medical Informatics using fuzzy cognitive maps based on fuzzy rule-extraction techniques", Applied Soft Computing, Vol. 11, Issue 1, p.p. 500–513, 2011.
4. E.I. Papageorgiou, "Fuzzy Cognitive Maps for Applied Sciences and Engineering From Fundamentals to Extensions and Learning Algorithms", Intelligent Systems Reference Library, Volume 54, 2014.

<br><br>

# FCM: How to Contribute

## Report Bugs

Report bugs and request enhancement by opening an issue on
[FCM issues @ Github](https://github.com/metomi/fcm/issues). If reporting a
bug, add a recipe for repeating it. If requesting an enhancement,
describe the use case in detail.

## Contribute Code

All contributions to FCM are made via pull requests against the *master*
branch of [metomi/fcm](https://github.com/metomi/fcm). New contributors
should add their details to the [Code Contributors](#code-contributors)
section of this file as part of their first request. The developer who
reviews each pull request is responsible for checking that the
contributor's name is listed in this file before merging the pull request
into *master*.

## Code Contributors

The following people have contributed to this code under the terms of
the Contributor Licence Agreement and Certificate of Origin detailed
below:

* Jim Bolton (Met Office, UK)
* Andrew Clark (Met Office, UK)
* Paul Cresswell (Met Office, UK)
* Martin Dix (CSIRO, Australia)
* Ben Fitzpatrick (Met Office, UK)
* Dave Matthews (Met Office, UK)
* Stephen Oxley (Met Office, UK)
* Matt Pryor (Met Office, UK)
* Roddy Sharp (Met Office, UK)
* Matt Shin (Met Office, UK)
* Stuart Whitehouse (Met Office, UK)
* Tim Pillinger (Met Office, UK)
* Joe Mancell (Met Office, UK)

(All contributors are identifiable with email addresses in the version
control logs or otherwise.)

## Contributor Licence Agreement and Certificate of Origin

By making a contribution to this project, I certify that:

(a) The contribution was created in whole or in part by me and I have
    the right to submit it, either on my behalf or on behalf of my
    employer, under the terms and conditions as described by this file;
    or

(b) The contribution is based upon previous work that, to the best of
    my knowledge, is covered under an appropriate licence and I have
    the right or permission from the copyright owner under that licence
    to submit that work with modifications, whether created in whole or
    in part by me, under the terms and conditions as described by
    this file; or

(c) The contribution was provided directly to me by some other person
    who certified (a) or (b) and I have not modified it.

(d) I understand and agree that this project and the contribution
    are public and that a record of the contribution (including my
    name and email address) is retained for the full term of
    the copyright and may be redistributed consistent with this project
    or the licence(s) involved.

(e) I, or my employer, grant to the UK Met Office and all recipients of
    this software a perpetual, worldwide, non-exclusive, no-charge,
    royalty-free, irrevocable copyright licence to reproduce, modify,
    prepare derivative works of, publicly display, publicly perform,
    sub-licence, and distribute this contribution and such modifications
    and derivative works consistent with this project or the licence(s)
    involved or other appropriate open source licence(s) specified by
    the project and approved by the
    [Open Source Initiative (OSI)](http://www.opensource.org/).

(f) If I become aware of anything that would make any of the above
    inaccurate, in any way, I will let the UK Met Office know as soon as
    I become aware.

(The FCM Contributor Licence Agreement and Certificate of Origin is
inspired by the Certificate of Origin used by Enyo and the Linux
Kernel.)

# Acknowledgement for non-FCM Work

Licences for non-FCM works included in this distribution can be
found in the licences/ directory.

Non-FCM works included in this distribution are listed below:

doc/etc/bootstrap/:
* Unmodified external software library copyright 2011-2015 Twitter, Inc
  released under the MIT license.
  See [Bootstrap](http://getbootstrap.com/).

svn-hooks/svnperms.py:
* Subversion repository pre-commit path-based permission checking utility,
  written by [Gustavo Niemeyer](mailto:gustavo@niemeyer.net) and released under
  Apache 2.0 license.
  Original source downloaded from r1295006 at:
  https://svn.apache.org/viewvc/subversion/trunk/tools/hook-scripts/svnperms.py
  This version is modified to allow custom permission message per repository.

=head1 NAME

fcm extract (ext)

=head1 SYNOPSIS

Invokes the deprecated FCM 1 extract system.

    fcm extract [OPTIONS] [CFGFILE]

=head1 ARGUMENTS

The path to a CFG file may be provided. Otherwise, the extract system searches
the default locations for an ext cfg file.

=head1 OPTIONS

=over 4

=item --clean

Clean the destination.

=item --full, -f

Run in full mode. If the option for full extract is specified, the
sub-directories created by previous extracts will be removed, so that the
current extract can start cleanly.

=item --ignore-lock

Ignore lock file. When an extract is invoked, it sets up a lock file in the
extract root directory.  The lock is normally removed at the end of the extract.
While the lock file is in place, the extract commands invoked in the same root
directory will fail. If you need to bypass this check for whatever reason, you
can invoke the extract system with this option.

=item --verbose=N, -v N

Specify the verbosity level. If specified, the verbosity level must be an
integer greater than 0. Verbosity level 0 is the quiet mode. Increasing the
verbosity level will increase the amount of diagnostic output.

=back

=cut

=head1 NAME

fcm branch-create (bcreate, bc)

=head1 SYNOPSIS

Creates a branch.

    fcm branch-create [OPTIONS] NAME [SOURCE]

=head1 ARGUMENTS

NAME is a short name for the branch, which should contain only characters in the
set [A-Za-z0-9_\-\.]. If the --ticket=N option is not specified and NAME
contains only a list of positive integers separated by [_-] (an underscore or a
hyphen), the command will assume that NAME also specifies the related ticket
numbers.

SOURCE can be an URL or a Subversion working copy. Otherwise, the current
working directory must be a working copy. The specified URL (or the URL of the
working copy) must be URL under a standard FCM project.

=head1 OPTIONS

=over 4

=item --branch-of-branch, --bob

If this option is specified and the SOURCE is a branch, it will create a new
branch from the SOURCE branch. Otherwise, the branch is created from the trunk.

=item --non-interactive

Do no interactive prompting. This option implies --svn-non-interactive.

=item --password=PASSWORD

Specify a password for write access to the repository.

=item --rev-flag=NONE|NORMAL|NUMBER

Specify a flag for determining the prefix of the branch name. The flag can be
the string "NORMAL", "NUMBER" or "NONE".  "NORMAL" is the default behaviour,
in which the branch name will be prefixed with a Subversion revision number if
the revision is not associated with a registered FCM revision keyword. If the
revision is registered with a FCM revision keyword, the keyword will be used in
place of the number. If "NUMBER" is specified, the branch name will always be
prefixed with a Subversion revision number. If "NONE" is specified, the branch
name will not be prefixed by a revision number or keyword.

=item --svn-non-interactive

Do no interactive prompting at commit time. This option is implied by
--non-interactive.

=item --switch

C<fcm switch> the current working directory (if it contains a relevant working
copy) to point to the newly created branch after the branch is created.

=item --ticket=N, -k N

Specify one (or more) Trac ticket. If specified, the ticket numbers will be
included in the commit log message. Multiple tickets can be set by specifying
this option multiple times, or by specifying the tickets in a comma-separated
list.

=item --type=TYPE, -t TYPE

Specify the type of the branch to be created. It must be one of the following:

 DEV::USER [DEV, USER] - a development branch for the user
 DEV::SHARE [SHARE]    - a shared development branch
 TEST::USER [TEST]     - a test branch for the user
 TEST::SHARE           - a shared test branch
 PKG::USER [PKG]       - a package branch for the user
 PKG::SHARE            - a shared package branch
 PKG::CONFIG [CONFIG]  - a configuration branch
 PKG::REL [REL]        - a release branch

If not specified, the default is to create a development branch for the current
user, i.e.  DEV::USER.

=back

=cut

=head1 NAME

fcm switch (sw)

=head1 SYNOPSIS

Update the working copy to a different URL.

    1. fcm switch URL[@REV1] [PATH]
    2. fcm switch --relocate FROM TO [PATH...]

Note: if --relocate is not specified, "fcm switch" will only support the options
--non-interactive, --revision (-r) and --quiet (-q). For detail, see the output
of "L<svn|svn> help switch".

=cut

=head1 NAME

fcm export-items

=head1 SYNOPSIS

Exports directories in SOURCE as a list of versioned items.

This command is used to support a legacy working practice, in which directories
in a source tree are regarded as individual versioned items.

    fcm export-items [OPTIONS] SOURCE

=head1 ARGUMENTS

The SOURCE should be the URL of a branch in a Subversion repository with the
standard FCM layout.

=head1 OPTIONS

=over 4

=item --config-file=PATH, --file=PATH, -f PATH

Specify the path to the configuration file.
(default=$PWD/fcm-export-items.cfg)

=item --directory=PATH, -C PATH

Specify the path to the destination. (default=$PWD)

=item --new, -N

Specify the new mode. In this mode, everything is re-exported. Otherwise, the
system runs in incremental mode, in which the version directories are only
updated if they do not already exist.

=back

=head1 CONFIGURATION

The configuration file should be in the deprecated FCM 1 configuration format.
The label in each entry should be a path relative to the source URL. If the path
ends in * then the path is expanded recursively and any sub-directories
containing regular files are added to the list of relative paths to export. The
value may be empty, or it may be a list of space separated "conditions". Each
condition is a conditional operator (>, >=, <, <=, == or !=) followed by a
revision number. The command uses the revision log to determine the revisions at
which the relative path has been updated in the source URL. If these revisions
also satisfy the "conditions" set by the user, they will be considered in the
export.

=head1 COPYRIGHT

Copyright (C) 2006-2021 British Crown (Met Office) & Contributors.

=cut

=head1 NAME

fcm branch-list (blist, bls)

=head1 SYNOPSIS

Searches and lists branches in projects. By default, it lists only branches
created by the current user.

    fcm branch-list [OPTIONS] [TARGET ...]

=head1 ARGUMENTS

If no TARGET is specified, the current working directory is assumed to be the
target. Each target must either be a URL[@REV] or a PATH[@REV] to a working copy
of a standard FCM project.

=head1 OPTIONS

=over 4

=item --only=DEPTH:PATTERN, ...

Specify a regular expression to match at various depth. E.g.  with the normal
FCM branch naming convention, C<--only=1:dev --only=2:fred> will display only
the development branches owned by user ID "fred". (This option is cumalative,
and overrides the --show-all and --user=PATTERN options.)

=item --quiet, -q

Decreases verbosity. Only prints branches matching the search criteria.

=item --show-all, -a

Print branches of all users. (This option overrides the --user=USER option.)

=item --url

Displays Subversion URL instead of FCM location keywords.

=item --user=PATTERN, -u PATTERN

Equivalent to --only=2:^PATTERN$ for projects with the normal FCM branch naming
convention. Lists branches created by the specified list of users instead of the
current user. With the normal FCM branch naming convention, you can also list
shared branches by specifying the user as "Share", configuration branches by
specifying the user as "Config" and release branches by specifying the user as
"Rel". (This option is cumalative.)

=back

=cut

=head1 NAME

fcm cmp-ext-cfg

=head1 SYNOPSIS

Compares the extract configurations of two similar FCM 1 extract configuration
files CFGFILE1 and CFGFILE2. This application is deprecated.

    fcm cmp-ext-cfg [OPTIONS] CFFILE1 CFGFILE2

=head1 OPTIONS

=over 4

=item --verbose=N, -v N

Specify the verbosity level. In normal mode with verbosity level 2 or above,
displays the change log of each revision.

=item --wiki-format=TARGET

Print revision tables in wiki format. In wiki mode, print revision tables in
wiki format. The argument to this option must be the Subversion URL or FCM URL
keyword of a FCM project associated with the intended Trac system. The --verbose
option has no effect in wiki mode.

=back

=cut

=head1 NAME

fcm browse (trac www)

=head1 SYNOPSIS

Invokes the browser for a version controlled target.

    fcm browse [OPTIONS] [TARGET ...]

=head1 ARGUMENTS

If TARGET is specified, it must be a FCM URL keyword, a Subversion URL or the
path to a local working copy. If not specified, the current working directory
is assumed to be a working copy. If the --browser option is specified, the
specified web browser command is used to launch the repository browser.
Otherwise, it attempts to use the default browser from the configuration
setting.

=head1 OPTIONS

=over 4

=item --browser=COMMAND

Specify the web browser command.

=back

=cut

=head1 NAME

fcm add

=head1 SYNOPSIS

    1. fcm add --check [PATH ...]

=head1 OPTIONS

=over 4

=item --check, -c

Check for any files or directories reported by "L<svn|svn> status" as not under
version control and add them.

=back

For other options, see output of "L<svn|svn> help add".

=cut

=head1 NAME

fcm cfg-print (cfg)

=head1 SYNOPSIS

Parses each FCM configuration file specified in the argument list, and prints
the result to STDOUT.

    fcm cfg-print [OPTIONS] [TARGET ...]

=head1 OPTIONS

=over 4

=item --fcm1, -1

If specified, targets should be in FCM 1 format. Otherwise, they should be in
FCM 2 format.

=back

=cut

=head1 NAME

fcm test-battery

=head1 SYNOPSIS

Run FCM self tests.

    fcm test-battery [...]

=head1 ARGUMENTS

Change directory to the FCM source tree, and runs this shell commmand:

    exec prove -j "${NPROC:-9}" -s -r "${@:-t}"

where NPROC is the number of processors on your computer. You can override the
L<prove|prove> command line by specifying extra arguments. E.g. If you do not
want to run the full test suite, you can specify the names of individual test
files or their containing directories as extra arguments. For example:

Run the full test suite with the default options.

    fcm test-battery

Run the full test suite with 12 processes.

    fcm test-battery -j 12

Run only tests under C<t/fcm-make/> with 12 processes.

    fcm test-battery -j 12 t/fcm-make

Run only C<t/fcm-make/10-log.t> in verbose mode.

    fcm test-battery -v t/fcm-make/10-log.t

=head1 OPTIONS

Environment variables:

=over 4

=item TEST_PROJECT

If this is set, run CM tests using a project sub-hierarchy in the test
repositories.

=item TEST_REMOTE_HOST

If this is set, run CM tests using an auto-generated Subversion server on the
host specified.

=back

=cut

=head1 NAME

fcm diff (di)

=head1 SYNOPSIS

Display the differences between two revisions or paths.

    1. fcm diff --branch [OPTIONS] [TARGET]
       fcm diff -b                 [TARGET]
    2. fcm diff [OPTIONS] [ARGS]

=over 4

=item 1.

This usage is deprecated. It is replaced by C<fcm branch-diff>. Type
C<fcm help branch-diff> for detail.

=item 2.

See the output of "L<svn|svn> help diff".

=back

=head1 OPTIONS

The following are additional options supported by C<fcm diff>.

=over 4

=item --graphical, -g

If this option is specified, the command uses a graphical tool to display the
differences. This option can be used in combination with all other valid
options except --diff-cmd and --extensions.

=item --summarise

This option is implemented in FCM as a wrapper to the Subversion --summarize
option. It prints only a summary of the results.

=back

=cut

=head1 NAME

fcm build (bld)

=head1 SYNOPSIS

Invokes the deprecated FCM 1 build system.

    fcm build [OPTIONS] [CFGFILE]

=head1 ARGUMENTS

The path to a CFGFILE may be provided. Otherwise, the build system searches the
default locations for a bld cfg file.

=head1 OPTIONS

If no option is specified, the options "-s 5 -t all -j 1 -v 1" are assumed.

=over 4

=item --archive, -a

Archive sub-directories on success. If archive mode is switched on, build
sub-directories that are only used in the build process will be archived to
TAR-GZIP files.

=item --clean

Clean the destination.

=item --full, -f

Run in full mode. If the option for full build is specified, the
sub-directories created by previous builds will be removed, so that the current
build can start cleanly.

=item --ignore-lock

Ignore lock file. When a build is invoked, it sets up a lock file in the build
root directory.  The lock is normally removed at the end of the build. While the
lock file is in place, the build commands invoked in the same root directory
will fail. If you need to bypass this check for whatever reason, you can invoke
the build system with this option.

=item --jobs=N, -j N

Specify the number of parallel jobs.

=item --stage=N, -s N

Run command up to a named stage. The stages are:

=over 4

=item "1", "s" or "setup"

Stage 1, setup.

=item "2", "pp" or "pre_process"

Stage 2, pre-process.

=item "3", "gd" or "generate_dependency"

Stage 3, generate dependency.

=item "4", "gi" or "generate_interface"

Stage 4, generate Fortran 9X interface.

=item "5", "m", "make"

Stage 5, make.

=back

=item --targets=TARGETS, -t TARGETS

List of build targets, delimited by (:). If specified, the default targets
declared in the configuration file will not be used.

=item --verbose=N, -v N

Specify the verbosity level. If specified, the verbosity level must be an
integer greater than 0. Verbosity level 0 is the quiet mode. Increasing the
verbosity level will increase the amount of diagnostic output.

=back

=cut

=head1 NAME

fcm branch-delete (bdelete bdel brm)

=head1 SYNOPSIS

Deletes a branch.

    fcm branch-delete [OPTIONS] [TARGET]

=head1 ARGUMENTS

TARGET can be an URL or a Subversion working copy. Otherwise, the current
working directory must be a working copy. The specified URL (or the URL of the
working copy) must be a URL under a valid branch in a standard FCM project.

=head1 OPTIONS

=over 4

=item --verbose, -v

Print extra information.

=item --show-all, -a

Set --show-children, --show-other and --show-siblings.

=item --show-children

Report children of the current branch.

=item --show-other

Report custom/ reverse merges into the current branch.

=item --show-siblings

Report merges with siblings of the current branch.

=item --non-interactive

Do no interactive prompting. This option implies --svn-non-interactive.

=item --password=PASSWORD

Specify a password for write access to the repository.

=item --svn-non-interactive

Do no interactive prompting at commit time. This option is implied by
--non-interactive.

=item --switch

If TARGET not specified in the argument list, C<fcm switch> the current working
copy to point to the C<trunk> after the branch deletion.

=back

=cut

=head1 NAME

fcm keyword-print (kp)

=head1 SYNOPSIS

Displays registered location and/or revision keywords.

    fcm keyword-print [OPTIONS] [TARGET ...]

=head1 ARGUMENTS

If no argument is specified, prints registered location keywords. Otherwise,
prints the location keyword and revision keywords for the specified target. If
--verbose is specified, prints the implied location keywords as well.

=head1 OPTIONS

=over 4

=item --verbose, -v

Increase the verbosity level.

=back

=cut

=head1 NAME

fcm project-create

=head1 SYNOPSIS

Creates a new project in a repository.

    fcm project-create [OPTIONS] PROJECT-NAME REPOS-ROOT-URL

=head1 ARGUMENTS

PROJECT-NAME is a valid name of a project for the given repository.

=head1 OPTIONS

=over 4

=item --non-interactive

Do no interactive prompting. This option implies --svn-non-interactive.

=item --password=PASSWORD

Specify a password for write access to the repository.

=item --svn-non-interactive

Do no interactive prompting at commit time. This option is implied by
--non-interactive.

=back

=cut

=head1 NAME

fcm branch-diff (bdiff, bdi)

=head1 SYNOPSIS

Show differences relative to the base of the target branch, i.e. the changes
available for merging from the target branch into its parent.

    fcm branch-diff [OPTIONS] [TARGET]

=head1 ARGUMENTS

If TARGET is specified, it must either be a URL or a working copy. Otherwise,
the target is the current directory which must be a working copy. The target
URL must be a branch in a standard FCM project.

=head1 OPTIONS

=over 4

=item --diff-cmd=PATH

Use PATH as I<diff> command.

=item --graphical, -g

Equivalent to C<--diff-cmd=fcm_graphic_diff>.

=item --summarize, --summarise

Show a summary of the results.

=item --xml

With --summarise, show a summary of the results in XML format.

=item --trac, -t

If TARGET is a URL, use Trac to display the diff.

=item --wiki

If TARGET is a URL, print Trac link for the diff.

=item --extensions=ARG, -x ARG

Options of the I<diff> command. See the help for "L<svn|svn> diff".

=back

=cut

=head1 NAME

fcm commit (ci)

=head1 SYNOPSIS

Send changes from your working copy to the repository. Invoke your favourite
editor to prompt you for a commit log message. Update your working copy
following the commit.

    fcm commit [OPTIONS] [PATH ...]

=head1 OPTIONS

=over 4

=item --dry-run

Allows you to add to the commit message without committing.

=item --svn-non-interactive

Do no interactive prompting at commit time.

=item --password=PASSWORD

Specify a password ARG.

=back

=cut

=head1 NAME

fcm loc-layout

=head1 SYNOPSIS

Parse the URL of a FCM/Subversion TARGET, and print its FCM layout information.

    fcm keyword-print [OPTIONS] [TARGET ...]

=head1 ARGUMENTS

If no argument is specified, TARGET is the current working directory.

=head1 OPTIONS

=over 4

=item --verbose, -v

Increase the verbosity level.

=back

=cut

=head1 NAME

fcm update (up)

=head1 SYNOPSIS

Bring changes from the repository into the working copy.

    fcm update [PATH...]

Note: "fcm update" only supports --non-interactive, --revision=REV (-r REV) and
--quiet (-q). For detail, see the output of "L<svn|svn> help update".

=cut

=head1 NAME

fcm help (h, usage, --help, --usage)

=head1 SYNOPSIS

Describes the usage of this program or its subcommands.

    fcm help [OPTIONS] [SUBCOMMAND...]

=head1 OPTIONS

=over 4

=item --quiet, -q

Decrease the verbosity level.

=item --verbose, -v

Increase the verbosity level.

=back

=cut

=head1 NAME

fcm delete (del, remove, rm)

=head1 SYNOPSIS

    fcm delete [OPTIONS] [TARGETS]

=head1 OPTIONS

=over 4

=item --check, -c

Check for any files or directories reported by "L<svn|svn> status" as missing
and schedule them for removal.

=back

For other options, see output of "L<svn|svn> help delete".

=cut

=head1 NAME

fcm merge

=head1 SYNOPSIS

Merge changes from a source into your working copy.

    1. fcm merge SOURCE
    2. fcm merge --custom  --revision N[:M] SOURCE
       fcm merge --custom  URL[\@REV1] URL[\@REV2]
    3. fcm merge --reverse --revision [M:]N

=over 4

=item 1.

If neither --custom nor --reverse is specified, the command merges changes
automatically from SOURCE into your working copy. SOURCE must be a valid
URL[@REV] of a branch in a standard FCM project. The base of the merge will be
calculated automatically based on the common ancestor and latest merge
information between the SOURCE and the branch of the working copy.

=item 2.

If --custom is specified, the command can be used in two forms.
  
In the first form, it performs a custom merge from the specified changeset(s) of
SOURCE into your working copy. SOURCE must be a valid URL[@REV] of a branch in
a standard FCM project. If a single revision is specified, the merge delta is (N
- 1):N of SOURCE. Otherwise, the merge delta, is N:M of SOURCE, where N < M.
     
In the second form, it performs a custom merge using the delta between the two
specified branch URLs. For each URL, if a peg revision is not specified, the
command will peg the URL with its last changed revision.

=item 3.

If --reverse is specified, the command performs a reverse merge of the
changeset(s) specified by the --revision=M:N option. If a revision is not
specified with --rev=M:N, it attempts to merge the delta COMMITTED:(COMMITTED -
1). If a single revision N is specified, the merge delta is N:(N - 1).
Otherwise, the merge delta is M:N, where M > N. Note that you do not have to
specify a SOURCE for a reverse merge, because the SOURCE should always be the
branch your working copy is pointing to.
  
=back

The command provide a commit log message template following the merge.

=head1 OPTIONS

=over 4

=item --auto-log

In automatic mode, adds the log messages of the merged revisions in the commit
log. Has no effect in other merge modes.

=item --dry-run

Try operation but make no changes.

=item --non-interactive

Do no interactive prompting.

=item --revision=REV, -r REV

Specify a (range of) revision number(s).

=item --verbose, -v

Print extra information.

=back

=cut

=head1 NAME

fcm make

=head1 SYNOPSIS

Invokes the FCM make system. See the user guide for detail.

    fcm make [OPTIONS] [DECLARATION ...]

=head1 ARGUMENTS

Each argument is considered to be a declaration line to append to the
configuration file.

=head1 OPTIONS

=over 4

=item --archive, -a

Switch on archive mode. In archive mode, intermediate files will be put into
TAR-GZIP archives on completion, e.g. extract system:
C<.fcm-make/cache/extract/>, and build system: C<build/include/> and
C<build/o/>.

The archive mode is not suitable for a make that will be inherited or used by
other makes.

=item --config-file-path=PATH, -F PATH

Specify paths for searching configuration files specified in relative paths.

=item --config-file=PATH, --file=PATH, -f PATH

Specify paths to the configuration files. (default = fcm-make.cfg in the
current working directory)

=item --directory=PATH, -C PATH

Change directory to C<PATH> before doing anything. (default = $PWD)

=item --ignore-lock

Ignore lock file. When the system is invoked, it sets up a lock file in the
destination.  The lock is normally removed when the system completes the make.
While the lock file is in place, another make invoked in the same destination
will fail. This option can be used to bypass this check.

=item --jobs=N, -j N

Specify the number of (child) processes that can be run simultaneously.

=item --name=NAME, -n NAME

Specify a name for the make, so that the command will search for
fcm-makeC<NAME>.cfg instead of fcm-make.cfg, and will write context files in
.fcm-makeC<NAME>/ and log files as fcm-makeC<NAME>.log, etc.

=item --new, -N

Remove items in the destination created by the previous make, and starts a new
make.

=item --quiet, -q

Decrease the verbosity level.

=item --verbose, -v

Increase the verbosity level.

=back

=cut

=head1 NAME

fcm conflicts (cf)

=head1 SYNOPSIS

Use graphical tool to resolve any conflicts within your working copy.

    fcm conflicts [PATH]

=head1 ARGUMENTS

Invoke a graphical merge tool to help you resolve conflicts in your working copy
at PATH. It prompts you to run "L<svn|svn> resolved" each time you have resolved
the conflicts in a text file.

=cut

=head1 NAME

fcm mkpatch

=head1 SYNOPSIS

Create patches from specified revisions of a URL

    fcm mkpatch [OPTIONS] URL [OUTDIR]

=head1 ARGUMENTS

If OUTDIR is specified, the output is sent to OUTDIR. Otherwise, the output will
be sent to a default location in the current directory ($PWD/fcm-mkpatch-out).
The output directory will contain the patch for each revision as well as a
script for importing the patch.

A warning is given if the URL is not of a branch in a FCM project or if it is a
sub-directory of a branch.

=head1 OPTIONS

=over 4

=item --exclude arg

Exclude a path in the URL. Multiple paths can be specified by using a
colon-separated list of paths, or by specifying this option multiple times.

The specified path must be a relative path of the URL. Glob patterns such as *
and ? are acceptable. Changes in an excluded path will not be considered in the
patch. A changeset containing changes only in the excluded path will not be
considered at all.

=item --organisation arg

This option can be used to specify the name of your organisation.

The command will attempt to parse the commit log message for each revision in
the patch. It will remove all merge templates, replace Trac links with a
modified string, and add information about the original changeset. If you
specify the name of your organisation, it will replace Trac links such as
"ticket:123" with "$organisation_ticket:123", and report the original changeset
with a message such as "$organisation_changeset:1000".  If the organisation
name is not specified then it defaults to "original".

=item --revision=arg, -r arg

Specify a revision number or a revision number range.

If a revision is specified with the --revision option, it will attempt to create
a patch based on the changes at that revision. If a revision is not specified,
it will attempt to create a patch based on the changes at the HEAD revision. If
a revision range is specified, it will attempt to create a patch for each
revision in that range (including the change in the lower range) where changes
have taken place in the URL. No output will be written if there is no change in
the given revision (range).

=back

=cut

=head1 NAME

fcm branch (br)

=head1 SYNOPSIS

    1. fcm branch --create --name NAME [OPTIONS] [SOURCE]
       fcm branch -c           -n NAME [OPTIONS] [SOURCE]
    2. fcm branch --delete             [OPTIONS] [TARGET]
       fcm branch -d                   [OPTIONS] [TARGET]
    3. fcm branch --info               [OPTIONS] [TARGET]
       fcm branch                      [OPTIONS] [TARGET]
    4. fcm branch --list               [OPTIONS] [TARGET]
       fcm branch -l                   [OPTIONS] [TARGET]

This command is deprecated. The 4 usages are replaced by:

=over 4

=item 1.

C<fcm branch-create>: Type C<fcm help branch-create> for detail.

=item 2.

C<fcm branch-delete>: Type C<fcm help branch-delete> for detail.

=item 3.

C<fcm branch-info>: Type C<fcm help branch-info> for detail.

=item 4.

C<fcm branch-list>: Type C<fcm help branch-list> for detail.

=back
=cut
